----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Mich - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------

local DF=DOF_namespace
local _

DOF_sharemedia = {
}

DOF_namespace.DF_talents = {
}

DOF_namespace.anchor={}
DOF_namespace.DFREFS={}
DOF_namespace.practiceNotRunning=true
DOF_namespace.practiceCheckBuff=true
DOF_namespace.practiceCheckDebuff=true
DOF_namespace.practiceCheckAura=false
DOF_namespace.currentCombos=0
DOF_namespace.luaCodeSeleted=nil
DOF_namespace.exportSeleted=nil

DOF_namespace.lock=true
DOF_namespace.configmode=false
DOF_namespace.currentTime=GetTime()
DOF_namespace.playerId = nil
DOF_namespace.playerClass = nil
DOF_namespace.playerLevel = nil
DOF_namespace.playerTalent = nil
DOF_namespace.playerTalentName = nil
DOF_namespace.playerpoint = nil
DOF_namespace.myArgs = ""
DOF_namespace.menace = 0
DOF_namespace.position3d = nil

DOF_namespace.configToLoad = nil
DOF_namespace.AnimaticToLoad = nil
DOF_namespace.haveTarget=nil

DOF_namespace.wipespell = true

DOF_namespace.environnement = getfenv(0)

DOF_namespace.DefaultSpell={
	spellIDs="0",
	abiUserText="",
	positionx=64,
	positiony=64,
	barpositionx=128,
	barpositiony=64,	
	width=32,
	height=32,
	sType="DebuffTarget",
	showcd=true,
	showdottimer=true,
	perso=true,
	combo=false,
	icon=0,
	abiInternalCD=0,
	timerbar=0,
	color={r=1,v=0,b=0,a=1},
	abiSound="",
	form={true,true,true,true,true,true,true,true},
	strongcheck=false,
	FX_enable=false,
	FX_stack=0,
	FX_name="Custom",
	FX_width=128,
	FX_height=128,
	FX_texture="Interface\\AddOns\\DotFocus\\datas\\fx.tga",
	FX_customtexture="",
	FX_mode="BLEND",
	FX_angle=0,
	FX_start_posx=0,
	FX_middle_posx=0,
	FX_end_posx=0,
	FX_start_posy=0,
	FX_middle_posy=0,
	FX_end_posy=0,
	FX_start_alpha=0,
	FX_middle_alpha=1,
	FX_end_alpha=0,
	FX_start_scale=0.5,
	FX_middle_scale=1,
	FX_end_scale=0.5,
	FX_start_width=1,
	FX_middle_width=1,
	FX_end_width=1,		
	FX_start_height=1,
	FX_middle_height=1,
	FX_end_height=1,
	FX_speed=40,
	FX_rotatespeed=0,
	FX_chakerpower=0,
	FX_pulsepowerX=0,
	FX_pulsespeedX=0,
	FX_pulsepowerY=0,
	FX_pulsespeedY=0,
	FX_pulsepowerZ=0,
	FX_pulsespeedZ=0,
	FX_timerenable=false,			
	FX_timerposx=0,
	FX_timerposy=0,
	FX_timersmall=true,
	FX_timerabove=false,
	FX_timerscale=0.40,
	FX_timeralpha=0.35,
	FX_textenabled=false,
	FX_fontPath="Interface\\AddOns\\DotFocus\\datas\\font_unispace.ttf",
	FX_textsize=12,
	FX_textColor={
		["a"] = 0.5,
		["r"] = 1,
		["v"] = 1,
		["b"] = 1,		
	},
	FX_textalign="CENTER",
	FX_textoffsetx=0,
	FX_textoffsety=-40,
	luaCode="",
	comboPoints=0,
	removable=true,
	FX_positionx=-100,
	FX_positiony=-100,
	FX_newLevel=250,
	TimerLimit=0,
	FX_progressTexture=0,
	FX_progressTextureFill=1,
	abiVieLimite=0,
	abiTextWarning=false,
	abiWarn=0,
	abiSoundWarningFile="",
	abiVieLimiteSens=1,
	abiLastCd=0,
	abiSoundWarning=0,
	TimerLimitSens=1,
	--abiTalent=0,
	abiTalents={true,true,true,true},
	abiBuffWarning=false,
	abiRdyMode=false,
	FX_OffMode=1,
	inRange=0,
	objScale=1,
	txtScale=1,
	abiPandemic=true,
	abiPandemicValue=0,
	showGlow=true,
	description="",
}

local indexToRemove = {
	["abiDotIndex"]=true,
	["abiOldTimeLeft"]=true,
	["abiSpellId"]=true,
	["abiAlphaPulse"]=true,
	["abiSoundWarningOk"]=true,
	["abiSpelltext"]=true,
	["abiPower"]=true,
	["abiIsaBuff"]=true,
	["abiSpellIdForCD"]=true,
	["abiStack"]=true,
	["abiAlert"]=true,
	["abiCD"]=true,
	["abiLast"]=true,
	["abiEnd"]=true,
	["abiFake"]=true,
	["abiTimeLeft"]=true,
	["abiRotatePulse"]=true,
	["abiStart"]=true,
	["abiRotatePulseInc"]=true,
	["abiCDAlert"]=true,
	["names"]=true,
	["abiDuration"]=true,
	["ids"]=true,
	["abiActiveCond"]=true,
}

function DOF_namespace:cleanUpConfig()
	
	local tempConfig = {}
	DOF_namespace:copyTable(DOF_config,tempConfig,true,true)
	DOF_config=table.wipe(DOF_config)
	DOF_namespace:copyTable(tempConfig,DOF_config,true)
	tempConfig=table.wipe(tempConfig)
		
end

StaticPopupDialogs["WIPESPELLS"] = {
	preferredIndex = 3,
  text = DOF_namespace.locale["loadconfigansw"],
  button1 = DOF_namespace.locale["loadconfigkeep"],
  button2 = DOF_namespace.locale["loadconfigdisc"],
	OnAccept = function()
		DOF_namespace:config_Loadok(DOF_namespace.configToLoad,false,false)
	end,
	OnCancel = function()
		DOF_namespace:config_Loadok(DOF_namespace.configToLoad,false,true)
	end,  
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
};

StaticPopupDialogs["LOADSPELLS"] = {
	preferredIndex = 3,
  text = DOF_namespace.locale["loadspellconfigansw"],
  button1 = DOF_namespace.locale["repyes"],
  button2 = DOF_namespace.locale["repno"],
	OnAccept = function()
		DOF_namespace:spellconfig_Loadok(DOF_namespace.configToLoad,false,false)
	end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
};

-- effacement valeur d'une table / erasing a value table
function DOF_namespace:clearTable(source,spellstoo)
	local function _clear(csource)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				csource[index]=nil
			else
				if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
					_clear(csource[index])
				end
			end
		end
	end
	_clear(source)
end

-- copy d'une table vers une autre / copy from one table to another
function DOF_namespace:copyTable(source,destination,spellstoo,skipIndex)
	local function _copy(csource,cdestination)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				
				if skipIndex==nil or not indexToRemove[index] then
					cdestination[index]=csource[index]
				end
				
			else
				
				if skipIndex==nil or not indexToRemove[index] then
				
					if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
				
						if cdestination[index]==nil or not cdestination[index] then
							cdestination[index]={}
						end
						
						_copy(csource[index],cdestination[index])
					
					end
					
				end
				
			end
		end
	end
	
	_copy(source,destination)
	
end

function DOF_namespace:deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

function DOF_namespace:dumptable(baseTable)

	local chemin=""
	local chaine
	
	local function _dumpit(baseTable,chemin)
	
		for index, value in pairs(baseTable) do

			if type(baseTable[index]) ~= "table" then
				-- valeur
				chaine=tostring(index).." -> "..tostring(value).."\n"
				DEFAULT_CHAT_FRAME:AddMessage(chaine)
			else
				-- sous-table
				_dumpit(baseTable[index],chemin.."."..tostring(index))
			end
			
		end
		
	end
	
	_dumpit(baseTable,"")	

end

	-- Compléte la configuration actuel avec les variables de la config par default
	-- Complete with the current configuration variables default config
function DOF_namespace:completeTable(tcurrent,tdefaut,force)
	local chemin="config"

	local function _check(current,defaut,chemin,force)
		--DOF_namespace:debugLine("chemin ",chemin)
		for index, value in pairs(defaut) do
			if type(defaut[index]) ~= "table" then
				if current[index]==nil then
					current[index]=defaut[index]
					--DOF_namespace:debugLine("SET "..tostring(index),defaut[index])
				end
			else
				if chemin~="config.spells" or force then
					if current[index]==nil or not current[index] then
						current[index]={}
						--DOF_namespace:debugLine("INDEX "..tostring(index),true)
					end				
					_check(current[index],defaut[index],chemin.."."..tostring(index),force)
				end
			end
		end
	end
	_check(tcurrent,tdefaut,chemin,force)	
end

function DOF_namespace:configSaved(name)
	local nbConf=getn(DOF_saved_configs)
	for i = 1,nbConf do
		if DOF_saved_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DOF_namespace:configBuildin(name)
	local nbConf=getn(DOF_namespace.DF_pred_configs)
	for i = 1,nbConf do
		if DOF_namespace.DF_pred_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DOF_namespace:configSetup(name)
	local nbConf=getn(DOF_namespace.additional_configs)
	for i = 1,nbConf do
		if DOF_namespace.additional_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DOF_namespace:config_CopyDroodFocusConfig(name,silence)
	DEFAULT_CHAT_FRAME:AddMessage("Testing for DroodFocus config")
end

function DOF_namespace:config_CopyDroodFocusConfig(name,silence)
  local srcConfig
  local targetConfig

  if (not DF_saved_configs) or (not DF_config) then
    DEFAULT_CHAT_FRAME:AddMessage("DroodFocus config not found! Start the game temporarily with both DotFocus and DroodFocus addon active and press button again!")
    return 0;
  end
  
  srcConfig = DF_config.configname
  targetConfig = srcConfig.." (DF import)"
  
  DEFAULT_CHAT_FRAME:AddMessage("DroodFocus found! Importing config "..srcConfig)
  
  DOF_config = DOF_namespace:deepcopy(DF_config)
  DOF_config.configname = targetConfig
  
  DEFAULT_CHAT_FRAME:AddMessage("Importing config"..targetConfig)
  DOF_namespace:config_Save(targetConfig, false)

end

function DOF_namespace:config_Save(name,silence)
	
	local conf
	
	if not name then name=DOF_config.configname end
	
	name=name:gsub("Default", "User")
	name=name:gsub("SetUp", "User")
	
	DOF_config.configname=name
	DOF_config.configversion=DOTFOCUS_CONFIGVERSION
	conf = DOF_namespace:configSaved(name)

	if conf==0 then
		conf=getn(DOF_saved_configs)+1
		DOF_saved_configs[conf] = {}
	end

	DOF_config.configversion=DOTFOCUS_CONFIGVERSION

	DOF_saved_configs[conf] = DOF_namespace:deepcopy(DOF_config)
	DOF_saved_configs[conf].configname=name

	DOF_namespace:options_SavedconfigLists()
	
	if (silence==nil) then
		DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["saved"]..name)
	end
	
end

function DOF_namespace:config_Load(name,showconfig)

	-- rien en parametre, prend la variable global
	if not name then name=DOF_namespace.configToLoad end
	
	-- rien en variable global, assigne config par défaut
	if name==nil then return end

	DOF_namespace.configToLoad=name;
	
	StaticPopup_Show("WIPESPELLS");

end

function DOF_namespace:spellconfig_Load(name,showconfig)

	-- rien en parametre, prend la variable global
	if not name then name=DOF_namespace.configToLoad end
	
	-- rien en variable global, assigne config par défaut
	if name==nil then return end
	
	DOF_namespace.configToLoad=name;
	
	StaticPopup_Show("LOADSPELLS");

end

function DOF_namespace:config_Loadok(name,showconfig,wipespell)

	local saveconfigPrimarySpe=DOF_config.configPrimarySpe
	local saveconfigSecondarySpe=DOF_config.configSecondarySpe
	local saveconfigTertiarySpe=DOF_config.configTertiarySpe
	local saveconfigQuaternarySpe=DOF_config.configQuaternarySpe		
	local conf
	
	DOF_namespace.pause=true

	DF:options_resetselectPt()

	DOF_namespace:hide_ooc_frame()
	
	if not name then name=DOF_namespace.configToLoad end

	if name==nil then return end
	
	if string.find(name, "Default") then
	
		conf = DOF_namespace:configBuildin(name)
		
		if conf~=0 then
			
			if (wipespell==true) then
				while getn(DOF_config.spells)>getn(DOF_namespace.DF_pred_configs[conf].spells) do
					table.remove(DOF_config.spells,getn(DOF_config.spells))
				end
			end
			
			DOF_namespace:options_hide()
		
			DOF_namespace:clearTable(DOF_config,wipespell)
			DOF_namespace:copyTable(DOF_namespace.DF_pred_configs[conf],DOF_config,wipespell)
			DOF_namespace:completeTable(DOF_config,DOF_namespace.DF_pred_configs[1],false)
			DOF_namespace:updateTable()
			
			DOF_namespace:cleanUpConfig()
			
			DOF_namespace:init_frames()
			DOF_namespace:toggle_toggle()
			DOF_namespace:DF_MinimapToggle()
		
			--DOF_namespace:replace_dotfocus()
		
			DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["loaded"]..DOF_config.configname)
			
			if (showconfig==true) then
				DOF_namespace:options_hide("DFOPTIONSelement");
				DOF_namespace:options_show("DFOPTIONSelement")
			end
			
			if (DOF_namespace.environnement["DFconfignamebox"]~=nil) then
				DOF_namespace.environnement["DFconfignamebox"]:Hide()
				DOF_namespace.environnement["DFconfignamebox"]:Show()		
			end
			
			DOF_config.configversion=DOTFOCUS_CONFIGVERSION

		end
	elseif string.find(name, "SetUp") then
	
		conf = DOF_namespace:configSetup(name)
		
		if conf~=0 then

			if (wipespell==true) then
				while getn(DOF_config.spells)>getn(DOF_namespace.additional_configs[conf].spells) do
					table.remove(DOF_config.spells,getn(DOF_config.spells))
				end
			end
			
			DOF_namespace:options_hide()
		
			DOF_namespace:clearTable(DOF_config,wipespell)
			DOF_namespace:copyTable(DOF_namespace.additional_configs[conf],DOF_config,wipespell)
			DOF_namespace:completeTable(DOF_config,DOF_namespace.DF_pred_configs[1],false)
			DOF_namespace:updateTable()
			
			DOF_namespace:cleanUpConfig()
			
			DOF_namespace:init_frames()
			DOF_namespace:toggle_toggle()
			DOF_namespace:DF_MinimapToggle()
		
			--DOF_namespace:replace_dotfocus()
		
			DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["loaded"]..DOF_config.configname)
			
			if (showconfig==true) then
				DOF_namespace:options_hide("DFOPTIONSelement");
				DOF_namespace:options_show("DFOPTIONSelement")
			end
			
			DOF_namespace.environnement["DFconfignamebox"]:Hide()
			DOF_namespace.environnement["DFconfignamebox"]:Show()		
			
			DOF_config.configversion=DOTFOCUS_CONFIGVERSION

		end
	elseif string.find(name, "Mod") then
	
		conf = DOF_namespace:configSetup(name)
		
		if conf~=0 then

			DOF_namespace:options_hide()
		
			DOF_namespace:copyTable(DOF_namespace.additional_configs[conf],DOF_config,false)
			
			DOF_namespace:init_frames()
			DOF_namespace:toggle_toggle()
			DOF_namespace:DF_MinimapToggle()
		
			DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["loaded"]..DOF_config.configname)
			
			if (showconfig==true) then
				DOF_namespace:options_hide("DFOPTIONSelement");
				DOF_namespace:options_show("DFOPTIONSelement")
			end
			
			DOF_namespace.environnement["DFconfignamebox"]:Hide()
			DOF_namespace.environnement["DFconfignamebox"]:Show()		
			
			DOF_config.configversion=DOTFOCUS_CONFIGVERSION

		end
		
	else
	
		conf = DOF_namespace:configSaved(name)
		
		if conf~=0 then

			if (wipespell==true) then
				while getn(DOF_config.spells)>getn(DOF_saved_configs[conf].spells) do
					table.remove(DOF_config.spells,getn(DOF_config.spells))
				end
			end
			
			DOF_namespace:options_hide()
			
			DOF_namespace:clearTable(DOF_config,wipespell)
			DOF_namespace:copyTable(DOF_saved_configs[conf],DOF_config,wipespell)
			DOF_namespace:completeTable(DOF_config,DOF_namespace.DF_pred_configs[1],false)
			DOF_namespace:updateTable()
			
			DOF_namespace:cleanUpConfig()
			
			DOF_namespace:init_frames()
			DOF_namespace:toggle_toggle()
			DOF_namespace:DF_MinimapToggle()
			
			--DOF_namespace:replace_dotfocus()
			
			DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["loaded"]..DOF_config.configname)
			
			if (showconfig==true) then
				DOF_namespace:options_hide("DFOPTIONSelement");
				DOF_namespace:options_show("DFOPTIONSelement")
			end
			
			if DOF_namespace.environnement["DFconfignamebox"] then
				DOF_namespace.environnement["DFconfignamebox"]:Hide()
				DOF_namespace.environnement["DFconfignamebox"]:Show()		
			end
			
			DOF_config.configversion=DOTFOCUS_CONFIGVERSION
			
		end
	end

	DOF_config.configPrimarySpe=saveconfigPrimarySpe
	DOF_config.configSecondarySpe=saveconfigSecondarySpe
	DOF_config.configTertiarySpe=saveconfigTertiarySpe
	DOF_config.configQuaternarySpe=saveconfigQuaternarySpe
	
	DOF_namespace.pause=false
	
	return
	
end

function DOF_namespace:spellconfig_Loadok(name)

	local conf
	
	DOF_namespace.pause=true
	DF:options_resetselectPt()
	DOF_namespace:hide_ooc_frame()
	
	if not name then name=DOF_namespace.configToLoad end
	
	conf = DOF_namespace:configBuildin(name)
	
	if conf~=0 then
		
		while getn(DOF_config.spells)>getn(DOF_namespace.DF_pred_configs[conf].spells) do
			table.remove(DOF_config.spells,getn(DOF_config.spells))
		end
		
		DOF_namespace:options_hide()
	
		DOF_namespace:clearTable(DOF_config.spells,true)
		DOF_namespace:copyTable(DOF_namespace.DF_pred_configs[conf].spells,DOF_config.spells,true)
		
		DOF_namespace:init_frames()
		DOF_namespace:toggle_toggle()
		DOF_namespace:DF_MinimapToggle()
		
	end
	
	DOF_namespace.pause=false
	
	return
	
end

function DOF_namespace:config_delete(numero)
	table.remove(DOF_saved_configs,numero)
	DOF_namespace:options_SavedconfigLists()
end

function DOF_namespace:config_Reset()

	DF:options_resetselectPt()
	DOF_namespace:hide_ooc_frame()

	while getn(DOF_config.spells)>getn(DOF_namespace.DF_pred_configs[1].spells) do
		table.remove(DOF_config.spells,getn(DOF_config.spells))
	end

	DOF_namespace:options_hide()
	
	DOF_namespace:clearTable(DOF_config,true)
	DOF_namespace:copyTable(DOF_namespace.DF_pred_configs[1],DOF_config,true)
	DOF_namespace:completeTable(DOF_config,DOF_namespace.DF_pred_configs[1],false)
	DOF_namespace:updateTable()
	
	DOF_namespace:cleanUpConfig()
	
	DOF_namespace:init_frames()
	DOF_namespace:toggle_toggle()
	DOF_namespace.environnement["DFconfignamebox"]:Hide()
	DOF_namespace.environnement["DFconfignamebox"]:Show()
	DOF_namespace.environnement["dfcombat"]:Hide()
	DOF_namespace.environnement["dfcombat"]:Show()
	DEFAULT_CHAT_FRAME:AddMessage(DOF_namespace.locale["reset"])
	DOF_config.configversion=DOTFOCUS_CONFIGVERSION
end

function DOF_namespace:updateTable()

	local anchorx
	local anchory
	local globalx
	local globaly
	local nbAnchors
	local oldx
	local oldy
	local tempx
	local tempy
	
	-- mise a jour des positions des ancres par rapport a l'ancre global
	-- (pas de changement sur les version supérieure a la 4.1.5)
	-- Update the positions of the anchors by the anchor global report
	-- (No change on the higher is 4.1.5)
	if tonumber(DOF_config.configversion)<415 then

		-- position de l'ancre 1
		-- position of the anchor 1
		tempx=DOF_config["anchor1"].positionx
		tempy=DOF_config["anchor1"].positiony	

		-- initialisation de l'ancre 0 a coté de l'ancre 1
		-- initilizing 0 anchor next to one of the anchor
		DOF_config["anchor0"].positionx = tempx-32
		DOF_config["anchor0"].positiony = tempy+32
		globalx=DOF_config["anchor0"].positionx
		globaly=DOF_config["anchor0"].positiony
		
		nbAnchors = 7
		-- replacement des ancre 1 a 7 par rapport a l'ancre 0
		-- replacement of anchor 1 to 7 relative to the anchor 0
		for i = 1,nbAnchors do
			
			tempx=DOF_config["anchor"..tostring(i)].positionx
			tempy=DOF_config["anchor"..tostring(i)].positiony
			
			if (tempx==0 and tempy==0) then
				DOF_config["anchor"..tostring(i)].positionx = -200
				DOF_config["anchor"..tostring(i)].positiony = 0
			else
				DOF_config["anchor"..tostring(i)].positionx = (tempx-globalx)
				DOF_config["anchor"..tostring(i)].positiony = (tempy-globaly)
			end
			
		end

		DOF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DOF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

	end
	
	if tonumber(DOF_config.configversion)<419 then
		
		-- ajout auto de l'effet special OOC
		-- auto-add special effect OOC
		if DOF_config.ooc.enable then

			table.insert(DOF_config.spells, 1, {})
			DOF_namespace:copyTable(DOF_namespace.DefaultSpell,DOF_config.spells[1],true)
			
			DOF_config.spells[1].spellIDs="16870"
			DOF_config.spells[1].sType="BuffPlayer"
			DOF_config.spells[1].icon=0
			DOF_config.spells[1].timerbar=0
			
			DOF_config.spells[1].FX_enable=true
			DOF_config.spells[1].FX_positionx=DOF_config.ooc.positionx
			DOF_config.spells[1].FX_positiony=DOF_config.ooc.positiony
			DOF_config.spells[1].FX_width=DOF_config.ooc.width
			DOF_config.spells[1].FX_height=DOF_config.ooc.height
			DOF_config.spells[1].FX_level=DOF_config.ooc.level
			DOF_config.spells[1].FX_mode=DOF_config.ooc.mode
			DOF_config.spells[1].FX_texture="Interface\\AddOns\\DotFocus\\datas\\fx_ooc.tga"

			DOF_config.spells[1].FX_start_scale=2.5
			DOF_config.spells[1].FX_middle_scale=1.25
			DOF_config.spells[1].FX_end_scale=2.5

			DOF_config.spells[1].FX_start_posx=0
			DOF_config.spells[1].FX_middle_posx=0
			DOF_config.spells[1].FX_end_posx=0
			
			DOF_config.spells[1].FX_start_posy=0
			DOF_config.spells[1].FX_middle_posy=0
			DOF_config.spells[1].FX_end_posy=0	

			DOF_config.spells[1].FX_start_alpha=0
			DOF_config.spells[1].FX_middle_alpha=1
			DOF_config.spells[1].FX_end_alpha=0

			DOF_config.spells[1].FX_speed=40

			DOF_config.spells[1].FX_rotatespeed=0.5
			DOF_config.spells[1].FX_chakerpower=1
			
		end
		
	end

	if tonumber(DOF_config.configversion)<427 then

		DOF_config.timerbars[1].width=DOF_config.timerbar.width
		DOF_config.timerbars[1].height=DOF_config.timerbar.height
		DOF_config.timerbars[1].texturePath=DOF_config.timerbar.texturePath
		DOF_config.timerbars[1].font1Path=DOF_config.timerbar.font1Path
		DOF_config.timerbars[1].font1Size=DOF_config.timerbar.font1Size
		DOF_config.timerbars[1].font2Path=DOF_config.timerbar.font2Path
		DOF_config.timerbars[1].font2Size=DOF_config.timerbar.font2Size
		DOF_config.timerbars[1].activeAlpha=DOF_config.timerbar.activeAlpha
		DOF_config.timerbars[1].inactiveAlpha=DOF_config.timerbar.inactiveAlpha
		DOF_config.timerbars[1].border=DOF_config.timerbar.border
		DOF_config.timerbars[1].borderSize=DOF_config.timerbar.borderSize
		DOF_config.timerbars[1].timeline=DOF_config.timerbar.timeline
		DOF_config.timerbars[1].prop=DOF_config.timerbar.prop
		DOF_config.timerbars[1].orderByTime=DOF_config.timerbar.orderByTime
		DOF_config.timerbars[1].level=DOF_config.timerbar.level
		DOF_config.timerbars[1].growup=DOF_config.timerbar.growup
		DOF_config.timerbars[1].stackup1=DOF_config.timerbar.stackup1
		DOF_config.timerbars[1].showSpark=DOF_config.timerbar.showSpark
		DOF_config.timerbars[1].activeAlphaCD=DOF_config.timerbar.activeAlphaCD
		DOF_config.timerbars[1].cdoffsety=DOF_config.timerbar.cdoffsety
		DOF_config.timerbars[1].textColor.a=DOF_config.timerbar.textColor.a
		DOF_config.timerbars[1].textColor.r=DOF_config.timerbar.textColor.r
		DOF_config.timerbars[1].textColor.v=DOF_config.timerbar.textColor.v
		DOF_config.timerbars[1].textColor.b=DOF_config.timerbar.textColor.b
		DOF_config.timerbars[1].borderColor.a=DOF_config.timerbar.borderColor.a
		DOF_config.timerbars[1].borderColor.r=DOF_config.timerbar.borderColor.r
		DOF_config.timerbars[1].borderColor.v=DOF_config.timerbar.borderColor.v
		DOF_config.timerbars[1].borderColor.b=DOF_config.timerbar.borderColor.b
		DOF_config.timerbars[1].cdColor.a=DOF_config.timerbar.cdColor.a
		DOF_config.timerbars[1].cdColor.r=DOF_config.timerbar.cdColor.r
		DOF_config.timerbars[1].cdColor.v=DOF_config.timerbar.cdColor.v
		DOF_config.timerbars[1].cdColor.b=DOF_config.timerbar.cdColor.b
		DOF_config.timerbars[1].textsoffsets[1].offsetx=DOF_config.timerbar.textsoffsets[1].offsetx
		DOF_config.timerbars[1].textsoffsets[1].offsety=DOF_config.timerbar.textsoffsets[1].offsety
		DOF_config.timerbars[1].textsoffsets[2].offsetx=DOF_config.timerbar.textsoffsets[2].offsetx
		DOF_config.timerbars[1].textsoffsets[2].offsety=DOF_config.timerbar.textsoffsets[2].offsety

		DOF_config.timerbars[2].width=DOF_config.timerbar.width2
		DOF_config.timerbars[2].height=DOF_config.timerbar.height2
		DOF_config.timerbars[2].texturePath=DOF_config.timerbar.texturePath
		DOF_config.timerbars[2].font1Path=DOF_config.timerbar.font1Path
		DOF_config.timerbars[2].font1Size=DOF_config.timerbar.font1Size
		DOF_config.timerbars[2].font2Path=DOF_config.timerbar.font2Path
		DOF_config.timerbars[2].font2Size=DOF_config.timerbar.font2Size
		DOF_config.timerbars[2].activeAlpha=DOF_config.timerbar.activeAlpha2
		DOF_config.timerbars[2].inactiveAlpha=DOF_config.timerbar.inactiveAlpha2
		DOF_config.timerbars[2].border=DOF_config.timerbar.border
		DOF_config.timerbars[2].borderSize=DOF_config.timerbar.borderSize
		DOF_config.timerbars[2].timeline=DOF_config.timerbar.timeline
		DOF_config.timerbars[2].prop=DOF_config.timerbar.prop2
		DOF_config.timerbars[2].orderByTime=DOF_config.timerbar.orderByTime
		DOF_config.timerbars[2].level=DOF_config.timerbar.level
		DOF_config.timerbars[2].growup=DOF_config.timerbar.growup
		DOF_config.timerbars[2].stackup1=DOF_config.timerbar.stackup2
		DOF_config.timerbars[2].showSpark=DOF_config.timerbar.showSpark
		DOF_config.timerbars[2].activeAlphaCD=DOF_config.timerbar.activeAlphaCD2
		DOF_config.timerbars[2].cdoffsety=DOF_config.timerbar.cdoffsety
		DOF_config.timerbars[2].textColor.a=DOF_config.timerbar.textColor.a
		DOF_config.timerbars[2].textColor.r=DOF_config.timerbar.textColor.r
		DOF_config.timerbars[2].textColor.v=DOF_config.timerbar.textColor.v
		DOF_config.timerbars[2].textColor.b=DOF_config.timerbar.textColor.b
		DOF_config.timerbars[2].borderColor.a=DOF_config.timerbar.borderColor.a
		DOF_config.timerbars[2].borderColor.r=DOF_config.timerbar.borderColor.r
		DOF_config.timerbars[2].borderColor.v=DOF_config.timerbar.borderColor.v
		DOF_config.timerbars[2].borderColor.b=DOF_config.timerbar.borderColor.b
		DOF_config.timerbars[2].cdColor.a=DOF_config.timerbar.cdColor.a
		DOF_config.timerbars[2].cdColor.r=DOF_config.timerbar.cdColor.r
		DOF_config.timerbars[2].cdColor.v=DOF_config.timerbar.cdColor.v
		DOF_config.timerbars[2].cdColor.b=DOF_config.timerbar.cdColor.b
		DOF_config.timerbars[2].textsoffsets[1].offsetx=DOF_config.timerbar.textsoffsets[1].offsetx
		DOF_config.timerbars[2].textsoffsets[1].offsety=DOF_config.timerbar.textsoffsets[1].offsety
		DOF_config.timerbars[2].textsoffsets[2].offsetx=DOF_config.timerbar.textsoffsets[2].offsetx
		DOF_config.timerbars[2].textsoffsets[2].offsety=DOF_config.timerbar.textsoffsets[2].offsety

		DOF_config.iconbars[1].fontSize=DOF_config.icons.fontSize
		DOF_config.iconbars[1].orderByTime=DOF_config.icons.orderByTime
		DOF_config.iconbars[1].decimal=DOF_config.icons.decimal
		DOF_config.iconbars[1].automatic=DOF_config.icons.automatic
		DOF_config.iconbars[1].showSpiral=DOF_config.icons.showSpiral
		DOF_config.iconbars[1].inactiveAlpha=DOF_config.icons.inactiveAlpha
		DOF_config.iconbars[1].level=DOF_config.icons.level
		DOF_config.iconbars[1].textsoffsets[1].visible=DOF_config.icons.textsoffsets[1].visible
		DOF_config.iconbars[1].textsoffsets[1].offsety=DOF_config.icons.textsoffsets[1].offsety
		DOF_config.iconbars[1].textsoffsets[1].align=DOF_config.icons.textsoffsets[1].align
		DOF_config.iconbars[1].textsoffsets[1].offsetx=DOF_config.icons.textsoffsets[1].offsetx
		DOF_config.iconbars[1].textsoffsets[1].size=DOF_config.icons.textsoffsets[1].size
		DOF_config.iconbars[1].textsoffsets[2].visible=DOF_config.icons.textsoffsets[2].visible
		DOF_config.iconbars[1].textsoffsets[2].offsety=DOF_config.icons.textsoffsets[2].offsety
		DOF_config.iconbars[1].textsoffsets[2].align=DOF_config.icons.textsoffsets[2].align
		DOF_config.iconbars[1].textsoffsets[2].offsetx=DOF_config.icons.textsoffsets[2].offsetx
		DOF_config.iconbars[1].textsoffsets[2].size=DOF_config.icons.textsoffsets[2].size
		DOF_config.iconbars[1].textsoffsets[3].visible=DOF_config.icons.textsoffsets[3].visible
		DOF_config.iconbars[1].textsoffsets[3].offsety=DOF_config.icons.textsoffsets[3].offsety
		DOF_config.iconbars[1].textsoffsets[3].align=DOF_config.icons.textsoffsets[3].align
		DOF_config.iconbars[1].textsoffsets[3].offsetx=DOF_config.icons.textsoffsets[3].offsetx
		DOF_config.iconbars[1].textsoffsets[3].size=DOF_config.icons.textsoffsets[3].size
		DOF_config.iconbars[1].colonne=DOF_config.icons.colonne
		DOF_config.iconbars[1].fontPath=DOF_config.icons.fontPath
		DOF_config.iconbars[1].mode=DOF_config.icons.mode
		DOF_config.iconbars[1].pointpa=DOF_config.icons.pointpa
		DOF_config.iconbars[1].width=DOF_config.icons.width
		DOF_config.iconbars[1].height=DOF_config.icons.height
		DOF_config.iconbars[1].speed=DOF_config.icons.speed
		DOF_config.iconbars[1].pulse=DOF_config.icons.pulse
		DOF_config.iconbars[1].activeAlpha=DOF_config.icons.activeAlpha
		DOF_config.iconbars[1].growup=DOF_config.icons.growup
		DOF_config.iconbars[1].textColor.a=DOF_config.icons.textColor.a
		DOF_config.iconbars[1].textColor.r=DOF_config.icons.textColor.r
		DOF_config.iconbars[1].textColor.v=DOF_config.icons.textColor.v
		DOF_config.iconbars[1].textColor.b=DOF_config.icons.textColor.b

		DOF_config.iconbars[2].fontSize=DOF_config.icons.fontSize
		DOF_config.iconbars[2].orderByTime=DOF_config.icons.orderByTime
		DOF_config.iconbars[2].decimal=DOF_config.icons.decimal
		DOF_config.iconbars[2].automatic=DOF_config.icons.automatic
		DOF_config.iconbars[2].showSpiral=DOF_config.icons.showSpiral
		DOF_config.iconbars[2].inactiveAlpha=DOF_config.icons.inactiveAlpha
		DOF_config.iconbars[2].level=DOF_config.icons.level
		DOF_config.iconbars[2].textsoffsets[1].visible=DOF_config.icons.textsoffsets[1].visible
		DOF_config.iconbars[2].textsoffsets[1].offsety=DOF_config.icons.textsoffsets[1].offsety
		DOF_config.iconbars[2].textsoffsets[1].align=DOF_config.icons.textsoffsets[1].align
		DOF_config.iconbars[2].textsoffsets[1].offsetx=DOF_config.icons.textsoffsets[1].offsetx
		DOF_config.iconbars[2].textsoffsets[1].size=DOF_config.icons.textsoffsets[1].size
		DOF_config.iconbars[2].textsoffsets[2].visible=DOF_config.icons.textsoffsets[2].visible
		DOF_config.iconbars[2].textsoffsets[2].offsety=DOF_config.icons.textsoffsets[2].offsety
		DOF_config.iconbars[2].textsoffsets[2].align=DOF_config.icons.textsoffsets[2].align
		DOF_config.iconbars[2].textsoffsets[2].offsetx=DOF_config.icons.textsoffsets[2].offsetx
		DOF_config.iconbars[2].textsoffsets[2].size=DOF_config.icons.textsoffsets[2].size
		DOF_config.iconbars[2].textsoffsets[3].visible=DOF_config.icons.textsoffsets[3].visible
		DOF_config.iconbars[2].textsoffsets[3].offsety=DOF_config.icons.textsoffsets[3].offsety
		DOF_config.iconbars[2].textsoffsets[3].align=DOF_config.icons.textsoffsets[3].align
		DOF_config.iconbars[2].textsoffsets[3].offsetx=DOF_config.icons.textsoffsets[3].offsetx
		DOF_config.iconbars[2].textsoffsets[3].size=DOF_config.icons.textsoffsets[3].size
		DOF_config.iconbars[2].colonne=DOF_config.icons.colonne2
		DOF_config.iconbars[2].fontPath=DOF_config.icons.fontPath
		DOF_config.iconbars[2].mode=DOF_config.icons.mode
		DOF_config.iconbars[2].pointpa=DOF_config.icons.pointpa
		DOF_config.iconbars[2].width=DOF_config.icons.width2
		DOF_config.iconbars[2].height=DOF_config.icons.height2
		DOF_config.iconbars[2].speed=DOF_config.icons.speed
		DOF_config.iconbars[2].pulse=DOF_config.icons.pulse
		DOF_config.iconbars[2].activeAlpha=DOF_config.icons.activeAlpha
		DOF_config.iconbars[2].growup=DOF_config.icons.growup
		DOF_config.iconbars[2].textColor.a=DOF_config.icons.textColor.a
		DOF_config.iconbars[2].textColor.r=DOF_config.icons.textColor.r
		DOF_config.iconbars[2].textColor.v=DOF_config.icons.textColor.v
		DOF_config.iconbars[2].textColor.b=DOF_config.icons.textColor.b

		-- ajout gestion blood in the water / adding blood in the water management
		table.insert(DOF_config.spells, 1, {})
		DOF_namespace:copyTable(DOF_namespace.DefaultSpell,DOF_config.spells[1],true)
		
		DOF_config.spells[1].spellIDs="0"
		DOF_config.spells[1].sType="Custom"
		DOF_config.spells[1].abiUserText="Blood in the water"
	
		DOF_config.spells[1].icon=0
		DOF_config.spells[1].timerbar=0
		DOF_config.spells[1].luaCode="current = UnitHealth(\"target\")\nmaxi = UnitHealthMax(\"target\")\npercent = current/maxi\nif percent<0.25 then\nreturn true\nelse\nreturn false\nend\n"	
		
		DOF_config.spells[1].FX_enable=true
		DOF_config.spells[1].FX_positionx=74
		DOF_config.spells[1].FX_positiony=-38
		DOF_config.spells[1].FX_width=128
		DOF_config.spells[1].FX_height=128
		DOF_config.spells[1].FX_level=127
		DOF_config.spells[1].FX_mode="BLEND"
		DOF_config.spells[1].FX_texture="Interface\\AddOns\\DotFocus\\datas\\fx_glow10.tga"

		DOF_config.spells[1].FX_start_scale=1.25
		DOF_config.spells[1].FX_middle_scale=1.25
		DOF_config.spells[1].FX_end_scale=1.25

		DOF_config.spells[1].FX_start_posx=0
		DOF_config.spells[1].FX_middle_posx=0
		DOF_config.spells[1].FX_end_posx=-0
		
		DOF_config.spells[1].FX_start_posy=250
		DOF_config.spells[1].FX_middle_posy=0
		DOF_config.spells[1].FX_end_posy=-65	

		DOF_config.spells[1].FX_start_alpha=0
		DOF_config.spells[1].FX_middle_alpha=0.65
		DOF_config.spells[1].FX_end_alpha=0

		DOF_config.spells[1].FX_start_height=0
		DOF_config.spells[1].FX_middle_height=1
		DOF_config.spells[1].FX_end_height=0.5

		DOF_config.spells[1].FX_speed=5

		DOF_config.spells[1].FX_pulsepowerZ=0.5
		DOF_config.spells[1].FX_pulsespeedZ=2
		DOF_config.spells[1].FX_rotatespeed=0
		DOF_config.spells[1].FX_chakerpower=0		

	end

	if tonumber(DOF_config.configversion)<429 then
		DOF_config.iconbars[1].inactiveCDAlpha=DOF_config.iconbars[1].inactiveAlpha
		DOF_config.iconbars[2].inactiveCDAlpha=DOF_config.iconbars[2].inactiveAlpha
	end

	if tonumber(DOF_config.configversion)<430 then
 		anchorx=DOF_config["anchor0"].positionx
 		anchory=DOF_config["anchor0"].positiony		
 		oldx=DOF_config.alert.positionx
 		oldy=DOF_config.alert.positiony
 		DOF_config.alert.positionx = anchorx+oldx
 		DOF_config.alert.positiony = anchory+oldy
	end
	
	if tonumber(DOF_config.configversion)<505 then
 		DOF_config.alert.positionx=0
 		DOF_config.alert.positiony=0
		DOF_config.alert.update505=true
	end
	
	DOF_config.combo.defenseCharge=false
	--DOF_config.combo.useInternalCombo=false
	
	if DOF_config.iconsRDYtext==nil then
		DOF_config.iconsRDYtext=DOF_namespace.locale["RDY"]
	end
	if DOF_config.barsRDYtext==nil then
		DOF_config.barsRDYtext=DOF_namespace.locale["RDY"]
	end

	if tonumber(DOF_config.configversion)<512 then
		DOF_config.combo.useInternalCombo=true
 		DOF_config.combo.useInternalComboText=true
 		DOF_config.dotTracker.enable=false
	end

	if tonumber(DOF_config.configversion)<514 then
		local nbSpells = getn(DOF_config.spells)
		local sp
		for sp = 1,nbSpells do
			if DOF_config.spells[sp].luaCode~="" then
				DOF_config.spells[sp].luaCode=DF:enc64(DOF_config.spells[sp].luaCode)
			end
		end
	end

	if tonumber(DOF_config.configversion)<608 then
		local nbSpells = getn(DOF_config.spells)
		local sp
		for sp = 1,nbSpells do
			DOF_config.spells[sp].abiPandemic=true
			DOF_config.spells[sp].abiPandemicValue=-1
		end
		
		DOF_config.range.range1=5185
		DOF_config.range.range2=5221
		
	end

	if tonumber(DOF_config.configversion)<611 then
		local nbSpells = getn(DOF_config.spells)
		local sp
		for sp = 1,nbSpells do
			-- rip?
			if (DOF_config.spells[sp].spellIDs=="1079") then
				DOF_config.spells[sp].luaCode=DF:enc64(DF.luaList[1].code)
			end
				
		end
		
	end
	
	if tonumber(DOF_config.configversion)<613 then
		DOF_config.dotTracker.dotsList="155722;1079;106832";
	end
	
	if tonumber(DOF_config.configversion)<618 then
		
		if (DOF_config.configPrimarySpe==nil) then
			DOF_config.configPrimarySpe="";
		end
		if (DOF_config.configSecondarySpe==nil) then
			DOF_config.configSecondarySpe="";
		end		
		if (DOF_config.configTertiarySpe==nil) then
			DOF_config.configTertiarySpe="";
		end
		if (DOF_config.configQuaternarySpe==nil) then
			DOF_config.configQuaternarySpe="";
		end		

	end
	
	if (DOF_config.iconbars[1].zoomed==nil) then
		DOF_config.iconbars[1].zoomed=false;
	end
	
	if (DOF_config.iconbars[2].zoomed==nil) then
		DOF_config.iconbars[2].zoomed=false;
	end
		
	DOF_config.combo.useInternalComboText=false;
	DOF_config.combo.useInternalCombo=false;
	DOF_config.dotPower.bigdotsValue=1;
			
end

function DOF_namespace:config_getname(numero)
	if DOF_saved_configs[numero] then
		return DOF_saved_configs[numero].configname
	else
		return ""
	end
end
